dfs CodeForces

来源:互联网 发布:光电转换器淘宝网 编辑:程序博客网 时间:2024/05/29 15:27

Each New Year Timofey and his friends cut down a tree of n vertices and bring it home. After that they paint all the n its vertices, so that the i-th vertex gets color ci.

Now it’s time for Timofey birthday, and his mother asked him to remove the tree. Timofey removes the tree in the following way: he takes some vertex in hands, while all the other vertices move down so that the tree becomes rooted at the chosen vertex. After that Timofey brings the tree to a trash can.

Timofey doesn’t like it when many colors are mixing together. A subtree annoys him if there are vertices of different color in it. Timofey wants to find a vertex which he should take in hands so that there are no subtrees that annoy him. He doesn’t consider the whole tree as a subtree since he can’t see the color of the root vertex.

A subtree of some vertex is a subgraph containing that vertex and all its descendants.

Your task is to determine if there is a vertex, taking which in hands Timofey wouldn’t be annoyed.

Input
The first line contains single integer n (2 ≤ n ≤ 105) — the number of vertices in the tree.

Each of the next n - 1 lines contains two integers u and v (1 ≤ u, v ≤ n, u ≠ v), denoting there is an edge between vertices u and v. It is guaranteed that the given graph is a tree.

The next line contains n integers c1, c2, …, cn (1 ≤ ci ≤ 105), denoting the colors of the vertices.

Output
Print “NO” in a single line, if Timofey can’t take the tree in such a way that it doesn’t annoy him.

Otherwise print “YES” in the first line. In the second line print the index of the vertex which Timofey should take in hands. If there are multiple answers, print any of them.

Example
Input
4
1 2
2 3
3 4
1 2 1 1
Output
YES
2
Input
3
1 2
2 3
1 2 3
Output
YES
2
Input
4
1 2
2 3
3 4
1 2 1 2
Output
NO

就是dfs,如果暴力搜索的话会在第七组样例时超时;可以想一下,如果满足题意的话,肯定是一条边的两个点的颜色不同,相同的话就直接不进行搜索,不同的话,则同时搜索这条边的两个点(与这个点相邻的所有点的子树颜色相同)。还有一个特殊情况就是所有点的颜色都相同(没有进行搜索),这时候只要输出任意一个点就行。
菜鸡啊,想了好久才弄明白。

#include<iostream>#include<cstdio>#include<cstring>#include<algorithm>using namespace::std;const int maxn=400000;int n,col[maxn];int head[maxn],vis[maxn];int ans;struct node{    int v,next;}edge[maxn];int cnt=0;void add_edge(int u,int v){    edge[cnt].v=v;    edge[cnt].next=head[u];    head[u]=cnt++;}int solve(int s){    for(int i=head[s];i!=-1;i=edge[i].next)    {        int to=edge[i].v;        if(col[to]!=col[s])        {            return to;        }    }    return -1;}void dfs(int s,int color){    vis[s]=1;    if(ans==0)    {        return;    }    for(int i=head[s];i!=-1;i=edge[i].next)    {        int to=edge[i].v;        if(vis[to])            continue;        vis[to]=1;        if(col[to]!=color)        {            ans=0;            return ;        }        dfs(to,color);    }}int judge(int s){    memset(vis,0,sizeof(vis));    vis[s]=1;    ans=1;    for(int i=head[s];i!=-1;i=edge[i].next)    {        int to=edge[i].v;        dfs(to,col[to]);        if(ans==0)        {            return 0;        }    }    return 1;}int main (){    cin>>n;    cnt=0;    memset(head,-1,sizeof(head));    for(int i=1;i<n;i++)    {        int xx,yy;        cin>>xx>>yy;        add_edge(xx,yy);        add_edge(yy,xx);    }    for(int i=1;i<=n;i++)    {        cin>>col[i];    }    for(int i=1;i<=n;i++)    {        int j=solve(i);        if(j!=-1)        {            if(judge(j))            {                puts("YES");                printf("%d\n",j);            }            else if(judge(i))            {                puts("YES");                printf("%d\n",i);            }            else             {                puts("NO");            }            return 0;        }    }    puts("YES");    puts("1");}
原创粉丝点击